#include <math.h>
#include <stdio.h>
#include <stdlib.h>
#include <time.h>

typedef unsigned _int32 uint;

bool *AtkinC(uint mx) {
  int e;
  uint g,i,a,d,n,nn;
  bool *sv=new bool[mx+1];
  for(i=0; i<=mx; ++i) sv[i]=false;
  sv[2]=true; sv[3]=true; // for 2 and 3
  for(a=11,d=12,g=24; a<=mx; a+=12,d+=12,g+=36) { // Boucle A
    for(n=a,e=g+24; (e>=48)&&(n<=mx); n+=(e-=72)) sv[n]=!sv[n];
    a+=d;
    for(n=a-12,e=g; (e>=48)&&(n<=mx); n+=(e-=72)) sv[n]=!sv[n];
    for(n=a,e=g+36; (e>=48)&&(n<=mx); n+=(e-=72)) sv[n]=!sv[n];
    a+=2*d;
    for(n=a-24,e=g-12;(e>=48)&&(n<=mx); n+=(e-=72)) sv[n]=!sv[n];
    for(n=a,e=g+24; (e>=48)&&(n<=mx); n+=(e-=72)) sv[n]=!sv[n];
    for(n=a+d-12,e=g; (e>=48)&&(n<=mx); n+=(e-=72)) sv[n]=!sv[n];
  }
  for(d=0,a=7; a<=mx; a+=(d+=24)) { // Boucle B
    for(uint n=a,e=-12; n<=mx; n+=(e+=72)) sv[n]=!sv[n];
    for(uint n=a+12,e=12; n<=mx; n+=(e+=72)) sv[n]=!sv[n];
  }
  for(d=4,a=5; a<=mx; a+=(d+=8)) { // Boucle C
    for(n=a,e=0; n<=mx; n+=(e+=8)) sv[n]=!sv[n];
    a+=(d+=8);
    for(n=a,e=0; n<=mx; n+=(e+=8)) sv[n]=!sv[n];
    a+=(d+=8);
    for(n=a,e=-24; n<=mx; n+=(e+=72)) sv[n]=!sv[n];
    for(n=a+24,e=24; n<=mx; n+=(e+=72)) sv[n]=!sv[n];
  }
  uint r=(int)sqrt((double)mx);
  for(n=5; n<=r; ++n)
    if(sv[n]) for(nn=n*n,i=nn; i<=mx; i+=nn) sv[i]=false;
  return sv;
} // William Voirol, Switzerland

int main() {
  printf("AtkinC: (bizarre avec bool[])");
  for(uint m=10,n=0; m<=1000000000; m*=10,n=0) {
    clock_t t=clock();
    bool *sv=AtkinC(m);
    t=clock()-t;
    for(uint i=0; i<=m; i++)
    if(sv[i]) ++n; // nombre de nombres premiers
    printf("\nm=%u, n=%u, t=%u ms",m,n,1000*t/CLOCKS_PER_SEC);
    delete(sv);
  }
  getchar();
}